// Copyright (c) Shinichi Yamagiwa, 2007
// ARM (AT91SAM9XE)GDBX^u _E[hTvvO

#define IRQ_TEST
//#define SWI_TEST

/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))


/* |[gRg[ */
#define PINSEL1	((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))

/* FGPIORg[ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1SET	((volatile unsigned int *)(0x3FFFC038))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))


/* ^C}R[ */
#define TIMER_T0IR		((volatile unsigned int *)(0xE0004000))
#define TIMER_T0TCR		((volatile unsigned int *)(0xE0004004))
#define TIMER_T0TC		((volatile unsigned int *)(0xE0004008))
#define TIMER_T0PR		((volatile unsigned int *)(0xE000400C))
#define TIMER_T0PC		((volatile unsigned int *)(0xE0004010))
#define TIMER_T0MCR		((volatile unsigned int *)(0xE0004014))
#define TIMER_T0MR0		((volatile unsigned int *)(0xE0004018))


/* 荞݃Rg[(VIC) */
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))

void software_exception_func(){

}

void prefetch_abort_func(){

}

void FIQ_func(){

}

int LED_val;

void IRQ_func(){
  int i, loop;

  if(LED_val == 0){
    *FGPIO_FIO1PIN =0x00000000;	/* P1[18] '0' -> LED ON */
    LED_val = 1;
  }
  else{
    *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
    LED_val = 0;
  }
  
  *TIMER_T0IR =1;		/* ^C}荞݃NA */
}

/* p[}l[WgRg[(PMC) */
#define PMC_SCER		((volatile unsigned int *)(0xFFFFFC00+0x00))
#define PMC_SCDR		((volatile unsigned int *)(0xFFFFFC00+0x04))
#define PMC_SCSR		((volatile unsigned int *)(0xFFFFFC00+0x08))

#define PMC_PCER		((volatile unsigned int *)(0xFFFFFC00+0x10))
#define PMC_PCDR		((volatile unsigned int *)(0xFFFFFC00+0x14))
#define PMC_PCSR		((volatile unsigned int *)(0xFFFFFC00+0x18))

#define CKGR_MOR		((volatile unsigned int *)(0xFFFFFC00+0x20))
#define CKGR_MCFR		((volatile unsigned int *)(0xFFFFFC00+0x24))
#define CKGR_PLLAR		((volatile unsigned int *)(0xFFFFFC00+0x28))
#define CKGR_PLLBR		((volatile unsigned int *)(0xFFFFFC00+0x2C))
#define PMC_MCKR		((volatile unsigned int *)(0xFFFFFC00+0x30))

#define PMC_PCK0		((volatile unsigned int *)(0xFFFFFC00+0x40))
#define PMC_PCK1		((volatile unsigned int *)(0xFFFFFC00+0x44))

#define PMC_SR			((volatile unsigned int *)(0xFFFFFC00+0x68))

#define MASTER_CLOCK	(198656000/2)

/* ėpI/Oo̓Rg[(PIOB) */
#define PIOB_PER		((volatile unsigned int *)(0xFFFFF600+0x00))
#define PIOB_PDR		((volatile unsigned int *)(0xFFFFF600+0x04))
#define PIOB_OER		((volatile unsigned int *)(0xFFFFF600+0x10))
#define PIOB_ODR		((volatile unsigned int *)(0xFFFFF600+0x14))
#define PIOB_IFER		((volatile unsigned int *)(0xFFFFF600+0x20))
#define PIOB_IFDR		((volatile unsigned int *)(0xFFFFF600+0x24))
#define PIOB_IFSR		((volatile unsigned int *)(0xFFFFF600+0x28))
#define PIOB_SODR		((volatile unsigned int *)(0xFFFFF600+0x30))
#define PIOB_ODSR		((volatile unsigned int *)(0xFFFFF600+0x38))
#define PIOB_PDSR		((volatile unsigned int *)(0xFFFFF600+0x3C))
#define PIOB_IER		((volatile unsigned int *)(0xFFFFF600+0x40))
#define PIOB_IDR		((volatile unsigned int *)(0xFFFFF600+0x44))
#define PIOB_IMR		((volatile unsigned int *)(0xFFFFF600+0x48))
#define PIOB_ISR		((volatile unsigned int *)(0xFFFFF600+0x4C))
#define PIOB_ASR		((volatile unsigned int *)(0xFFFFF600+0x70))
#define PIOB_BSR		((volatile unsigned int *)(0xFFFFF600+0x74))
#define PIOB_OWER		((volatile unsigned int *)(0xFFFFF600+0xA0))
#define PIOB_OWDR		((volatile unsigned int *)(0xFFFFF600+0xA4))

/* ėpI/Oo̓Rg[(PIOC) */
#define PIOC_PER		((volatile unsigned int *)(0xFFFFF800+0x00))
#define PIOC_PDR		((volatile unsigned int *)(0xFFFFF800+0x04))
#define PIOC_OER		((volatile unsigned int *)(0xFFFFF800+0x10))
#define PIOC_ODR		((volatile unsigned int *)(0xFFFFF800+0x14))
#define PIOC_ODSR		((volatile unsigned int *)(0xFFFFF800+0x38))
#define PIOC_PDSR		((volatile unsigned int *)(0xFFFFF800+0x3C))
#define PIOC_ASR		((volatile unsigned int *)(0xFFFFF800+0x70))
#define PIOC_BSR		((volatile unsigned int *)(0xFFFFF800+0x74))

/* OoXRg[(Static Memory Contlloer) */
#define SMC0_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x00))
#define SMC0_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x04))
#define SMC0_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x08))
#define SMC0_MODE		((volatile unsigned int *)(0xFFFFEC00+0x0C))

#define SMC2_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x20))
#define SMC2_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x24))
#define SMC2_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x28))
#define SMC2_MODE		((volatile unsigned int *)(0xFFFFEC00+0x2C))

#define SMC4_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x40))
#define SMC4_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x44))
#define SMC4_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x48))
#define SMC4_MODE		((volatile unsigned int *)(0xFFFFEC00+0x4C))

#define SMC5_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x50))
#define SMC5_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x54))
#define SMC5_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x58))
#define SMC5_MODE		((volatile unsigned int *)(0xFFFFEC00+0x5C))

/* oXRg[ݒp[^ */
#define AT91C_SM_NWE_SETUP		(1 << 0)
#define AT91C_SM_NCS_WR_SETUP	(0 << 8)
#define AT91C_SM_NRD_SETUP		(1 << 16)
#define AT91C_SM_NCS_RD_SETUP	(0 << 24)

#define AT91C_SM_NWE_PULSE 		(7 << 0)
#define AT91C_SM_NCS_WR_PULSE	(7 << 8)
#define AT91C_SM_NRD_PULSE		(7 << 16)
#define AT91C_SM_NCS_RD_PULSE	(7 << 24)
 
#define AT91C_SM_NWE_CYCLE 		(10 << 0)
#define AT91C_SM_NRD_CYCLE		(10 << 16)

#define AT91C_SMC_READMODE		(1 <<  0) // (SMC) Read Mode
#define AT91C_SMC_WRITEMODE		(1 <<  1) // (SMC) Write Mode
#define AT91C_SMC_NWAITM		(3 <<  5) // (SMC) NWAIT Mode

#define AT91C_SMC_NWAITM_NWAIT_DISABLE	(0x0 <<  5) // (SMC) External NWAIT disabled.
#define AT91C_SMC_DBW_WIDTH16	(0x1 << 12) // (SMC) 16 bits.
#define AT91C_SMC_DBW_WIDTH32	(0x2 << 12) // (SMC) 32 bits.

/* SDRAMRg[ */
#define SDRAM_BaseAddres		0x20000000
#define SDRAMC_MR		((volatile unsigned int *)(0xFFFFEA00+0x00))
#define SDRAMC_TR		((volatile unsigned int *)(0xFFFFEA00+0x04))
#define SDRAMC_CR		((volatile unsigned int *)(0xFFFFEA00+0x08))
#define SDRAMC_LPR		((volatile unsigned int *)(0xFFFFEA00+0x0C))
#define SDRAMC_IER		((volatile unsigned int *)(0xFFFFEA00+0x10))
#define SDRAMC_IDR		((volatile unsigned int *)(0xFFFFEA00+0x14))
#define SDRAMC_IMR		((volatile unsigned int *)(0xFFFFEA00+0x1C))
#define SDRAMC_ISR		((volatile unsigned int *)(0xFFFFEA00+0x20))
#define SDRAMC_MDR		((volatile unsigned int *)(0xFFFFEA00+0x24))

/* CCFG */
#define CCFG_EBICSA		((volatile unsigned int *)(0xFFFFEF10+0x0C))

/* SDRAMRg[ݒp[^ */
#define AT91C_SDRAMC_NC_9			(0x1) // (SDRAMC) 9 Bits
#define AT91C_SDRAMC_NR_13			(0x2 <<  2) // (SDRAMC) 13 Bits
#define AT91C_SDRAMC_CAS_2			(0x2 <<  5) // (SDRAMC) 2 cycles
#define AT91C_SDRAMC_NB_4_BANKS		(0x1 <<  4) // (SDRAMC) 4 banks
#define AT91C_SDRAMC_DBW_32_BITS	(0x0 <<  7) // (SDRAMC) 32 Bits datas bus
#define AT91C_SDRAMC_TWR_2			(0x2 <<  8) // (SDRAMC) Value :  2
#define AT91C_SDRAMC_TRC_7			(0x7 << 12) // (SDRAMC) Value :  7
#define AT91C_SDRAMC_TRP_2			(0x2 << 16) // (SDRAMC) Value :  2
#define AT91C_SDRAMC_TRCD_2			(0x2 << 20) // (SDRAMC) Value :  2
#define AT91C_SDRAMC_TRAS_5			(0x5 << 24) // (SDRAMC) Value :  5
#define AT91C_SDRAMC_TXSR_8			(0x8 << 28) // (SDRAMC) Value :  8

#define AT91C_SDRAMC_MODE_NORMAL_CMD	(0x0) // (SDRAMC) Normal Mode
#define AT91C_SDRAMC_MODE_NOP_CMD		(0x1) // (SDRAMC) Issue a NOP Command at every access
#define AT91C_SDRAMC_MODE_PRCGALL_CMD	(0x2) // (SDRAMC) Issue a All Banks Precharge Command at every access
#define AT91C_SDRAMC_MODE_LMR_CMD		(0x3) // (SDRAMC) Issue a Load Mode Register at every access
#define AT91C_SDRAMC_MODE_RFSH_CMD		(0x4) // (SDRAMC) Issue a Refresh
#define AT91C_SDRAMC_MODE_EXT_LMR_CMD	(0x5) // (SDRAMC) Issue an Extended Load Mode Register
#define AT91C_SDRAMC_MODE_DEEP_CMD		(0x6) // (SDRAMC) Enter Deep Power Mode

/* EHb`hbO^C}䃌WX^ */
#define WDT_MR			((volatile unsigned int *)(0xFFFFFD40+0x04))

/* ZbgRg[䃌WX^ */
#define RSTC_MR			((volatile unsigned int *)(0xFFFFFD00+0x08))

/* tbVRg[䃌WX^(EEFC) */
#define EEFC_FMR		((volatile unsigned int *)(0xFFFFFA00+0x00))

/* AhoXh荞݃Rg[(AIC) */
#define AIC_SMR0		((volatile unsigned int *)(0xFFFFF000+0x000))
#define AIC_SMR1		((volatile unsigned int *)(0xFFFFF000+0x004))
#define AIC_SMR2		((volatile unsigned int *)(0xFFFFF000+0x008))
#define AIC_SMR3		((volatile unsigned int *)(0xFFFFF000+0x00C))
#define AIC_SMR6		((volatile unsigned int *)(0xFFFFF000+0x018))
#define AIC_SMR7		((volatile unsigned int *)(0xFFFFF000+0x01C))
#define AIC_ISR			((volatile unsigned int *)(0xFFFFF000+0x108))
#define AIC_IPR			((volatile unsigned int *)(0xFFFFF000+0x10C))
#define AIC_IMR			((volatile unsigned int *)(0xFFFFF000+0x110))
#define AIC_IECR		((volatile unsigned int *)(0xFFFFF000+0x120))
#define AIC_IDCR		((volatile unsigned int *)(0xFFFFF000+0x124))
#define AIC_ICCR		((volatile unsigned int *)(0xFFFFF000+0x128))
#define AIC_ISCR		((volatile unsigned int *)(0xFFFFF000+0x12C))

#define	USE_UART_CH		1	/* UART`l0`1 */

#if (USE_UART_CH == 0)
	#define COM_BaseAdr		0xFFFB0000	/* USART0 */
#endif
#if (USE_UART_CH == 1)
	#define COM_BaseAdr		0xFFFB4000	/* USART1 */
#endif

#define COM_CR			((volatile unsigned int *)(COM_BaseAdr+0x00))
#define COM_MR			((volatile unsigned int *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned int *)(COM_BaseAdr+0x08))
#define COM_IDR			((volatile unsigned int *)(COM_BaseAdr+0x0C))
#define COM_IMR			((volatile unsigned int *)(COM_BaseAdr+0x10))
#define COM_CSR			((volatile unsigned int *)(COM_BaseAdr+0x14))
#define COM_RHR			((volatile unsigned int *)(COM_BaseAdr+0x18))
#define COM_THR			((volatile unsigned int *)(COM_BaseAdr+0x1C))
#define COM_BRGR		((volatile unsigned int *)(COM_BaseAdr+0x20))
#define COM_RTOR		((volatile unsigned int *)(COM_BaseAdr+0x24))
#define COM_TTGR		((volatile unsigned int *)(COM_BaseAdr+0x28))


/* PLLNbNn */
void pll_initialize(void)
{
	/* NbNn */
	*CKGR_MOR = 0x00004001;		/* COSCCl[u */
	while((*PMC_SR & 1)==0){}	/* CIV[^bN܂ő҂ */

	/* PLLAݒ [ MULA=97(0x61) / DIVA=9 ] */
	*CKGR_PLLAR = 0x2060BF09;	/* (18.432MHz*97)/9 = 198.656MHz */
	while((*PMC_SR & 2)==0){}	/* PLLAbN܂ő҂ */

	/* PCK = PLLA = 2 * MCK */
	*PMC_MCKR = 0x00000100;
	while((*PMC_SR & 8)==0){}	/* }X^NbNbN܂ő҂ */

	/* Switch MCK on PLLA output */
	*PMC_MCKR = 0x00000102;
	while((*PMC_SR & 8)==0){}	/* }X^NbNbN܂ő҂ */

	/* PLLBݒ [ MULB=73(0x49) / DIVA=14(0xE)] */
	*CKGR_PLLBR = 0x10483F0E;	/* (18.432MHz*73)/14 = 96.1MHz */
	while((*PMC_SR & 4)==0){}	/* PLLBbN܂ő҂ */

	*PMC_PCK0 = 1;			/* OoXNbN0o */
	*PMC_PCK1 = 1;			/* OoXNbN1o */
	*PMC_SCER = 0x3C;		/* PCK0/PCK1/UDP/UHPCl[u */
	*PMC_PCER = 0x1C;		/* PIO A~C NbNCl[u */
}


/* OoXRg[ */
void external_bus_initialize(void)
{
	/* f[^oX16rbgA */
	*PIOB_PDR = 0xC0000000;	/* PB31/PB30fBZ[u */
	*PIOB_ASR = 0xC0000000;	/* PCK1/PCK0 */
	*PIOC_PDR = 0xFFFFEFF0;	/* PCxxfBZ[u */
	*PIOC_ASR = 0xFFFFAF30;	/* D31~D16/NWAIT/FIQ/NCS2/A25/NCS5/NCS4/A24/A23 */
	*PIOC_BSR = 0x000040C0;	/* IRQ2/CFCE1/CFCE2 */
	*PMC_PCER = 0x10;		/* PIO C NbNCl[u */

	/* `bvZNg0oXRg[(16bit NOR Flash) */
	*SMC0_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC0_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC0_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC0_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM_NWAIT_DISABLE | AT91C_SMC_DBW_WIDTH16;

	/* `bvZNg2oXRg[(BLANCA) */
	*SMC2_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC2_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC2_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC2_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM | AT91C_SMC_DBW_WIDTH32;

	/* `bvZNg4oXRg[(BLANCA) */
	*SMC4_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC4_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC4_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC4_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM | AT91C_SMC_DBW_WIDTH32;

	/* `bvZNg5oXRg[(BLANCA) */
	*SMC5_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC5_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC5_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC5_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM | AT91C_SMC_DBW_WIDTH32;
}


/* SDRAMԏ */
void sdram_write(unsigned int offset, unsigned int data)
{
	unsigned int *p;
	p=(unsigned int *)(SDRAM_BaseAddres + offset);
	*p=data;
}

/* SDRAMRg[SDRAM */
void sdram_initialize(void)
{
	int i;

	/* CCFG */
	*CCFG_EBICSA = (*CCFG_EBICSA | 0x00000002);	/* `bvZNg1 SDRAM */

	/* SDRAMR}hWX^ݒ */
	*SDRAMC_CR	= (AT91C_SDRAMC_NC_9 | AT91C_SDRAMC_NR_13 | AT91C_SDRAMC_CAS_2 | AT91C_SDRAMC_NB_4_BANKS | AT91C_SDRAMC_DBW_32_BITS | AT91C_SDRAMC_TWR_2 | AT91C_SDRAMC_TRC_7 | AT91C_SDRAMC_TRP_2 | AT91C_SDRAMC_TRCD_2 | AT91C_SDRAMC_TRAS_5 | AT91C_SDRAMC_TXSR_8);
	*SDRAMC_MDR	= 1;	/* [p[SDRAMݒ */

	for (i =0; i< 1000;i++){}	/* EFCg */

	*SDRAMC_MR  = AT91C_SDRAMC_MODE_NOP_CMD;	// Set NOP 
	sdram_write(0x00, 0x00000000);	// Perform NOP

	*SDRAMC_MR  = AT91C_SDRAMC_MODE_PRCGALL_CMD;// Set PRCHG AL
	sdram_write(0x00, 0x00000000);	// Perform PRCHG

	for (i =0; i< 10000;i++){}	/* EFCg */

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 1st CBR
	sdram_write(0x04, 0x00000001);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 2 CBR
	sdram_write(0x08, 0x00000002);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 3 CBR
	sdram_write(0x0C, 0x00000003);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 4 CBR
	sdram_write(0x10, 0x00000004);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 5 CBR
	sdram_write(0x14, 0x00000005);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 6 CBR
	sdram_write(0x18, 0x00000006);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 7 CBR
	sdram_write(0x1C, 0x00000007);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 8 CBR
	sdram_write(0x20, 0x00000008);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_LMR_CMD;	// Set LMR operation
	sdram_write(0x24, 0xCAFEDEDE);	// Perform LMR burst=1, lat=2

	*SDRAMC_TR	= (MASTER_CLOCK * 7)/1000000;	// Set Refresh Timer

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_NORMAL_CMD;	// Set Normal mode
	sdram_write(0x00, 0x00000000);	// Perform Normal mode
}

/* CPUŗL */
void CPU_Initialize(void)
{
  *WDT_MR   = 0x3FFFAFFF;	/* EHb`hbOfBZ[u */
  *RSTC_MR  = 0xA5000001;	/* ZbgSWZbgCl[u */
  *EEFC_FMR = 0x00000600;	/* tbVEFCgݒ */
  
  /* PLLNbNn */
  pll_initialize();
  
  /* OoXRg[ */
  external_bus_initialize();

  /* SDRAMRg[SDRAM */
  sdram_initialize();
}

/* ZbgRg[ */
#define RSTC_CR 		((volatile unsigned int *)(0xFFFFF000+0xD00))
#define RSTC_SR 		((volatile unsigned int *)(0xFFFFF000+0xD04))
#define RSTC_MR 		((volatile unsigned int *)(0xFFFFF000+0xD08))

int main(){
  int i,j;

  //  while(1){}

  //  CPU_Initialize();

  /* PIO A~B NbNCl[u */
  *PMC_PCER = 0x0C;
  
  /* fBbvXCb`(PB25~22)/LED(PB21~18) */
  *PIOB_PER = 0x03FC0000;	/* PB25~18Cl[u */
  *PIOB_OWER= 0x003C0000;	/* PB21~18݃Cl[u */
  *PIOB_SODR= 0x003C0000;	/* LED */
  *PIOB_ODR = 0x03C00000;	/* PB25~22͕ */
  *PIOB_OER = 0x003C0000;	/* PB21~18o͕ */

  // LED̓_
  for(;;){
    /* fBbvXCb`̏ԂLEDɏo */
    *PIOB_ODSR = 1 << 18;
    for(j=0;j<1000000;j++){}
    *PIOB_ODSR = 0 << 18;
    for(j=0;j<1000000;j++){}
  }

  while(1){}

  return 0;
}
