/* CQ Monitor Target Functions */
/* Copyright (C) Shinichi Yamagiwa */

#include<stdio.h>

#include "monitor.h"

/* AhoXh荞݃Rg[(AIC) */
#define AIC_SMR0		((volatile unsigned int *)(0xFFFFF000+0x000))
#define AIC_SMR1		((volatile unsigned int *)(0xFFFFF000+0x004))
#define AIC_SMR2		((volatile unsigned int *)(0xFFFFF000+0x008))
#define AIC_SMR3		((volatile unsigned int *)(0xFFFFF000+0x00C))
#define AIC_SMR6		((volatile unsigned int *)(0xFFFFF000+0x018))
#define AIC_SMR7		((volatile unsigned int *)(0xFFFFF000+0x01C))
#define AIC_ISR			((volatile unsigned int *)(0xFFFFF000+0x108))
#define AIC_IPR			((volatile unsigned int *)(0xFFFFF000+0x10C))
#define AIC_IMR			((volatile unsigned int *)(0xFFFFF000+0x110))
#define AIC_IECR		((volatile unsigned int *)(0xFFFFF000+0x120))
#define AIC_IDCR		((volatile unsigned int *)(0xFFFFF000+0x124))
#define AIC_ICCR		((volatile unsigned int *)(0xFFFFF000+0x128))
#define AIC_ISCR		((volatile unsigned int *)(0xFFFFF000+0x12C))

#define	USE_UART_CH		1	/* UART`l0`1 */

#if (USE_UART_CH == 0)
	#define COM_BaseAdr		0xFFFB0000	/* USART0 */
#endif
#if (USE_UART_CH == 1)
	#define COM_BaseAdr		0xFFFB4000	/* USART1 */
#endif

#define COM_CR			((volatile unsigned int *)(COM_BaseAdr+0x00))
#define COM_MR			((volatile unsigned int *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned int *)(COM_BaseAdr+0x08))
#define COM_IDR			((volatile unsigned int *)(COM_BaseAdr+0x0C))
#define COM_IMR			((volatile unsigned int *)(COM_BaseAdr+0x10))
#define COM_CSR			((volatile unsigned int *)(COM_BaseAdr+0x14))
#define COM_RHR			((volatile unsigned int *)(COM_BaseAdr+0x18))
#define COM_THR			((volatile unsigned int *)(COM_BaseAdr+0x1C))
#define COM_BRGR		((volatile unsigned int *)(COM_BaseAdr+0x20))
#define COM_RTOR		((volatile unsigned int *)(COM_BaseAdr+0x24))
#define COM_TTGR		((volatile unsigned int *)(COM_BaseAdr+0x28))

// stdin̊荞݂֎~Ԃɂ
void init_stdin_int(){
}

// stdin̊荞݂
void enable_stdin_int(){
#if (USE_UART_CH == 0)
	*AIC_IECR = 0x40;		/* 荞݃Cl[u */
#endif
#if (USE_UART_CH == 1)
	*AIC_IECR = 0x80;		/* 荞݃Cl[u */
#endif
	*COM_IER = 1;			/* M荞 */
}

// stdin̊荞݂֎~
void disable_stdin_int(){
  *COM_IER = 0;			/* M荞 */
}

extern unsigned int monitor_registers[];
void show_register(){
  int i;

  for(i=0;i<16;i++)
    printf("r%d\t=\t0x%.8x\r\n",i,monitor_registers[i]);
  printf("cpsr\t=\t0x%.8x\r\n",i,monitor_registers[16]);
}    
