// Copyright (c) Shinichi Yamagiwa, 2009
// ARM (LPC2388)GDBX^u _E[hTvvO
// Thumb[hMRSAMSR߂̎s

// \tgEFA荞݂Ő䂷Ƃ
//#define SWI_BASED

/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))


/* |[gRg[ */
#define PINSEL1	((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))


/* ^C}R[ */
#define TIMER_T0IR		((volatile unsigned int *)(0xE0004000))
#define TIMER_T0TCR		((volatile unsigned int *)(0xE0004004))
#define TIMER_T0TC		((volatile unsigned int *)(0xE0004008))
#define TIMER_T0PR		((volatile unsigned int *)(0xE000400C))
#define TIMER_T0PC		((volatile unsigned int *)(0xE0004010))
#define TIMER_T0MCR		((volatile unsigned int *)(0xE0004014))
#define TIMER_T0MR0		((volatile unsigned int *)(0xE0004018))


/* FGPIORg[ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1SET	((volatile unsigned int *)(0x3FFFC038))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))

/* 荞݃Rg[(VIC) */
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))

/* CPUŗL */
void CPU_Initialize(void)
{
  /*** PLLNbNU ***/

  /* łPLL쒆ꍇ͒~ */
  if ( *CLK_PLLSTAT & (1<<25) ) {
    /* PLLCON - PLL Enable & disconnected */
    *CLK_PLLCON   =0x00000001;
    /* PLL Feed operation */
    *CLK_PLLFEED  =0x000000AA;
    *CLK_PLLFEED  =0x00000055;
  }
  /* PLLCON - PLL Disable & disconnected(PLLS~) */
  *CLK_PLLCON   =0x00000000;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  *SYS_SCS = 0x21;	/* 12MHz OSC Enable & FGPIO Select */
  while((*SYS_SCS&0x40) == 0){}	/* OSCSTAT Wait */

  /* CLKSRCSEL - MASTER oscillator select */
  *CLK_CLKSRCSEL=0x00000001;

  /* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
  *CLK_PLLCFG   =0x000B008F;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* PLLCON - PLL Enable & disconnected */
  *CLK_PLLCON   =0x00000001;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* CPU Clock Divider 1/4 */
  *CLK_CCLKCFG  =0x00000003;
  /* USB Clock Divider 1/6 */
  *CLK_USBCLKCFG=0x00000005;

  while ( ((*CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

  /* PLLCON - PLL Enable & Connected */
  *CLK_PLLCON   =0x00000003;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;
  while ( ((*CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */
}

#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))

char RecvData(){
  while((*COM_LSR & 0x1) == 0){};	/* CEXe[^X擾 */
  return (unsigned char)*COM_RBR;	/* Mf[^Ԃ */
}

void SendData(char data){
  while((*COM_LSR & 0x20)==0) {}	/* Mobt@󂭂܂ő҂ */
  *COM_THR = (unsigned char)data;	/* Mf[^ */
}

void UART_puts(char *s){

  while(1){
    if(*s == '\0') return;
    SendData(*s);
    s++;
  }
}

int LED_val;
int int_status;
void CPU_EnableInterrupt();
void CPU_DisableInterrupt();

/* |[gRg[ */
#define PINSEL0			((volatile unsigned int *)(0xE002C000))
#define PINSEL1			((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))

/* NbNp[Rg[ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define POW_PCONP		((volatile unsigned int *)(0xE01FC0C4))

int main(){
  int i, j;

#ifdef SWI_BASED
  int_status = 1;
#endif
  CPU_Initialize();

  // UARTTXD0RXD0g
  /* |[gUART[hɐݒ(UART0) */
  *PINSEL0=(*PINSEL0 & 0xFFFFFF0F) | 0x50;	/* TXD0&RXD0I */
  /* UART0NbN 72MHz/4=18MHz */
  *CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFF3F);
  /* UART0p[Cl[u */
  *POW_PCONP = *POW_PCONP | 8;	/* UART0 */

  
  /* UARTݒ */
  *COM_LCR =0x80;   /* ݒ背WX^I */
  *COM_DLL =37;     /* 18MHz19200bpsݒ */
  *COM_DLM =0;
  *COM_FDR =(/*MULVAL=*/ 12 <<4)|/*DIVADDVAL=*/7; /* FDRWX^ݒ */
  *COM_LCR =0x03;		/* peBȂ/Xgbvrbg1/f[^8rbg */


  *SYS_SCS = *SYS_SCS | 1;	/* FGPIO Select */
  // LEDP1[18]ɐڑĂ̂ŁAfW^I/Oɐݒ
  *PINSEL1 =0;			/* GPIO Select */
  *GPIO_PINMODE1=0;			/* PullUp Enable */

  /* LED_ݒ */
  *FGPIO_FIO1DIR =0x00040000;	/* P1[18] OutPut */
  *FGPIO_FIO1MASK=0x00000000;	/* P1[18] Non Mask */
  *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */

  /* ^C}Rg[ւ̋NbNݒ */
  /* CPUNbNƓ */
  // *CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3) | (1 << 2);
  /* CPUNbN1/2 */
  // *CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3) | (1 << 3);
  // CPUNbN1/4 */
  *CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3);

  /* ^C}0̃p[^ݒ */
  *TIMER_T0PR  = 0x00000000;		/* vXP[ */
  *TIMER_T0MR0 = 18000000;		/* NbNg=1b */
  *TIMER_T0MCR = 0x00000003;		/* MatchTCNA&荞 */


  *TIMER_T0TCR = 1;	/* ^C}X^[g*/

  LED_val = 0; // LED̏ԂɂB

  /* 荞݃Rg[ݒ */
  *VIC_IntSelect = *VIC_IntSelect & (~0x10);	/* IRQI */
  *VIC_IntEnable = 0x10;	/* ^C}0̂ݗL */

  UART_puts("Int Enabled.\n\r");

  while(1){
    char c;
    c = RecvData();
#ifdef SWI_BASED
      asm volatile ("SWI 0x11");
#else
    if(c == '1'){
      CPU_EnableInterrupt();
      UART_puts("Int Enabled.\n\r");
    }
    else{
      CPU_DisableInterrupt();
      UART_puts("Int Disabled.\n\r");
    }
#endif
  }

  return 0;
}
