/* ARM(LPC2388)GDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

#define UART_BAUDRATE 19200
#define USE_INTERNAL_RAM

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case EXCEPTION_PREFETCH_ABORT:
    case EXCEPTION_DATA_ABORT:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case EXCEPTION_SOFTWARE:
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case EXCEPTION_IRQ:
    case EXCEPTION_FIQ:
      sigval = TARGET_SIGNAL_INT;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}

#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))

/* 荞݃Rg[(VIC) */
#define VIC_IRQStatus	((volatile unsigned int *)(0xFFFFF000))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))

#define UART_INT_BIT 0x00000040


/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* |[gRg[ */
#define PINSEL0			((volatile unsigned int *)(0xE002C000))
#define PINSEL1			((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))

/* FGPIORg[ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1SET	((volatile unsigned int *)(0x3FFFC038))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))

/* NbNp[Rg[ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define POW_PCONP		((volatile unsigned int *)(0xE01FC0C4))


/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))


/* M荞݋ */
void enable_int(){
  // UARTIRQLɂ
  *COM_IER =1;
}

/* M荞݋֎~ */
void disable_int(){
  // UARTIRQ𖳌ɂ
  *COM_IER =0;
}

/* EHb`hbO^C}[Rg[ */
#define WDMOD ((volatile unsigned int *)0xE0000000)
#define WDTC ((volatile unsigned int *)0xE0000004)
#define WDFEED ((volatile unsigned int *)0xE0000008)
#define WDTV ((volatile unsigned int *)0xE000000C)
#define WDCLKSEL ((volatile unsigned int *)0xE0000010)


void gdb_stub_kill_command(){
  // EHb`hbN^C}[ŃtZbg
  /* WDTNbN 4MHz/4=18MHz */
  *WDCLKSEL = 0x0; // 4MHz IV[^
  *CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFFFC);

  *WDTC = 0xF4240; // 1sec?
  *WDMOD = 0x3; // Reset mode
  *WDFEED = 0xAA;
  *WDFEED = 0x55;

  while(1){}
}

// GDBgVA|[g܂B
void init_serial (){
  // UARTTXD0RXD0g
  /* |[gUART[hɐݒ(UART0) */
  *PINSEL0=(*PINSEL0 & 0xFFFFFF0F) | 0x50;	/* TXD0&RXD0I */
  /* UART0NbN 72MHz/4=18MHz */
  *CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFF3F);
  /* UART0p[Cl[u */
  *POW_PCONP = *POW_PCONP | 8;	/* UART0 */

  /* 荞݃Rg[ݒ(UARTx) */
  *VIC_IntSelect = *VIC_IntSelect & (~UART_INT_BIT);
  *VIC_IntEnable = *VIC_IntEnable |   UART_INT_BIT;
  
  /* UARTݒ */
  *COM_LCR =0x80;   /* ݒ背WX^I */
  *COM_DLL =37;     /* 18MHz19200bpsݒ */
  *COM_DLM =0;
  *COM_FDR =(/*MULVAL=*/ 12 <<4)|/*DIVADDVAL=*/7; /* FDRWX^ݒ */
  *COM_LCR =0x03; /* peBȂ/Xgbvrbg1/f[^8rbg */


  // UARTIRQLɂ
  *COM_IER =1;
}

#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  while((*COM_LSR & 0x1) == 0){};	/* CEXe[^X擾 */
  return (char)*COM_RBR;	/* Mf[^Ԃ */
}

// 1M֐B
void putDebugChar (char ch){
  while((*COM_LSR & 0x20)==0) {}	/* Mobt@󂭂܂ő҂ */
  *COM_THR = (unsigned char)ch;	/* Mf[^ */
}

void _illegalinst_func(void){
  gdb_handle_exception(EXCEPTION_ILL_INSN);
}

void _int_func(void){
  if((*VIC_IRQStatus & (1<<6))){ // UART0
    if(((*COM_IIR >> 1) & 0x7) == 0x2){ // Receive Data Available
      gdb_handle_exception(EXCEPTION_IRQ);
    }
  }
}

void _bus_func(void){
  gdb_handle_exception(EXCEPTION_DATA_ABORT);
}


/* CPUŗL */
void CPU_Initialize(void)
{
  /*** PLLNbNU ***/

  /* łPLL쒆ꍇ͒~ */
  if ( *CLK_PLLSTAT & (1<<25) ) {
    /* PLLCON - PLL Enable & disconnected */
    *CLK_PLLCON   =0x00000001;
    /* PLL Feed operation */
    *CLK_PLLFEED  =0x000000AA;
    *CLK_PLLFEED  =0x00000055;
  }
  /* PLLCON - PLL Disable & disconnected(PLLS~) */
  *CLK_PLLCON   =0x00000000;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  *SYS_SCS = 0x21;	/* 12MHz OSC Enable & FGPIO Select */
  while((*SYS_SCS&0x40) == 0){}	/* OSCSTAT Wait */

  /* CLKSRCSEL - MASTER oscillator select */
  *CLK_CLKSRCSEL=0x00000001;

  /* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
  *CLK_PLLCFG   =0x000B008F;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* PLLCON - PLL Enable & disconnected */
  *CLK_PLLCON   =0x00000001;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* CPU Clock Divider 1/4 */
  *CLK_CCLKCFG  =0x00000003;
  /* USB Clock Divider 1/6 */
  *CLK_USBCLKCFG=0x00000005;

  while ( ((*CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

  /* PLLCON - PLL Enable & Connected */
  *CLK_PLLCON   =0x00000003;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;
  while ( ((*CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */
}

void cpu_init_at_main(){
  CPU_Initialize();
}


int IsAccesibleRAM(int addr){
  if(addr >= 0x40000000 && addr < 0x40010000)
    return 1;
  return 0;
}

#define ARM_MODE 0
#define THUMB_MODE 1
volatile struct StepInst{
  int used;
  unsigned int InstTrue;
  unsigned int AddrTrue;
  unsigned int ModeTrue;
  unsigned int InstFalse;
  unsigned int AddrFalse;
  unsigned int ModeFalse;
} StepInstInfo;

void InitStep(){
  StepInstInfo.used = 0;
}


#define ILLEGAL_INST_ARM 0xe7ffdefe
#define ILLEGAL_INST_THUMB 0xbebe

extern registers[];

void RegisterStep(){
  unsigned int InstTmp;
  int cond, opcode, opcode_sub;
  int addr_offset;
  int CurrInstAddr;
  int Rd, Rm, Rn;
  int RnVal, RmVal;
  int DestAddr;
  int I_bit, P_bit, U_bit, W_bit, S_bit;
  int LoadAddr;
  int shift, shift_imm;
  int index, i;
  int C_flag;
  int shifter_operand;
  int rotate_imm;
  int Rs, RsVal;
  unsigned int LoadVal;
  int LRVal;
  int T_bit;

  CurrInstAddr = registers[PC];
  if((registers[CPSR] & (1<<5)) == 0)
    T_bit = 0;
  else
    T_bit = 1;


  // ============= THUMB[hŎsĂꍇ
  if(T_bit > 0){
    InstTmp = (unsigned int)(*((volatile unsigned short *)CurrInstAddr));

    if(((InstTmp>>12) & 0xF) == 0xd){ // B(1)
      addr_offset = InstTmp & 0xFF;
      if((addr_offset & (1<<7)) != 0)
	addr_offset |= ~0xFF;
      addr_offset <<= 1;

      StepInstInfo.ModeFalse = THUMB_MODE; 
      StepInstInfo.AddrFalse = CurrInstAddr + 2;
      StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;


      StepInstInfo.ModeTrue = THUMB_MODE; 
      StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 4;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      StepInstInfo.used = 1;
      return;
    }
    else if(((InstTmp>>11) & 0x1F) == 0x1C){ // B(2)
      addr_offset = InstTmp & 0x7FF;
      if((addr_offset & (1<<10)) != 0)
	addr_offset |= ~0x7FF;
      addr_offset <<= 1;    

      StepInstInfo.ModeFalse = THUMB_MODE; 
      StepInstInfo.AddrFalse = CurrInstAddr + 2;
      StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

      StepInstInfo.ModeTrue = THUMB_MODE; 
      StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 4;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      StepInstInfo.used = 1;
      return;
    }
    else if(((InstTmp>>13) & 0x7) == 0x7 && ((InstTmp >> 11) & 0x3) != 0){ // BL, BLX (1)
      if(((InstTmp >> 11) & 0x3) == 2){ // H=10 2߂1߂̖߁BGCC̊֐Ăяoł͂g
	addr_offset = InstTmp & 0x7FF;
	if((addr_offset & (1<<10)) == 0) // g
	  addr_offset = (addr_offset << 12);
	else
	  addr_offset = (~0x7FF | addr_offset) << 12;
	InstTmp = (unsigned int)(*((volatile unsigned short *)(CurrInstAddr + 2)));
	unsigned int addr_offset2 = InstTmp & 0x7FF;
	addr_offset = addr_offset | (addr_offset2 << 1);
	if(((InstTmp >> 11) & 0x3) == 1) // H=01 (BLX)
	  addr_offset = (addr_offset & 0xFFFFFFFC);
	
	StepInstInfo.ModeFalse = THUMB_MODE; 
	StepInstInfo.AddrFalse = CurrInstAddr + 4;
	StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
	*((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

	StepInstInfo.ModeTrue = THUMB_MODE; 
	StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 4;
	StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	StepInstInfo.used = 1;
	return;
      }
    }
    else if(((InstTmp>>7) & 0x1FF) == 0x8f){ // BLX (2)
      Rm = (InstTmp >> 3) & 0xF;
      // Read Rm
      RmVal = registers[Rm];

      StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

      StepInstInfo.ModeTrue = THUMB_MODE; 
      StepInstInfo.ModeFalse = THUMB_MODE; 
      StepInstInfo.AddrTrue = RmVal & 0xFFFFFFFE;
      StepInstInfo.AddrFalse = StepInstInfo.AddrTrue;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      StepInstInfo.InstFalse = StepInstInfo.InstTrue;
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      StepInstInfo.used = 1;
      return;
    }
    else if(((InstTmp>>7) & 0x1FF) == 0x8e){ // BX GCC͂Ŋ֐Ԃ
      Rm = (InstTmp >> 3) & 0xF;
      // Read Rm
      RmVal = registers[Rm];

      StepInstInfo.AddrTrue = RmVal & 0xFFFFFFFE;
      StepInstInfo.AddrFalse = StepInstInfo.AddrTrue;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      StepInstInfo.InstFalse = StepInstInfo.InstTrue;

      if((RmVal & 0x1) == 0){
	StepInstInfo.ModeTrue = ARM_MODE; 
	StepInstInfo.ModeFalse = ARM_MODE; 
	*((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
      }
      else{
	StepInstInfo.ModeTrue = THUMB_MODE; 
	StepInstInfo.ModeFalse = THUMB_MODE; 
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      }
      StepInstInfo.used = 1;
      return;
    }
    else if((InstTmp>>8) == 0x46){ // MOV (3)
      if((InstTmp & (1<<7)) != 0 && ((InstTmp & 0x7) == 0x7)){ // PC
	Rm = ((InstTmp >> 3) & 0x7);
	if((InstTmp & (1<<6)) != 0)
	  Rm += 8;
	// Read Rm
	RmVal = registers[Rm];

	StepInstInfo.ModeFalse = THUMB_MODE; 
	StepInstInfo.AddrFalse = CurrInstAddr + 2;
	StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
	*((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

	StepInstInfo.ModeTrue = THUMB_MODE; 
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	StepInstInfo.AddrTrue = RmVal;
	StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
	StepInstInfo.used = 1;
	return;
      }
    }

    StepInstInfo.ModeFalse = THUMB_MODE; 
    StepInstInfo.AddrFalse = CurrInstAddr + 2;
    StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
    *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;



    StepInstInfo.ModeTrue = THUMB_MODE; 
    StepInstInfo.AddrTrue = StepInstInfo.AddrFalse;
    StepInstInfo.InstTrue = StepInstInfo.InstFalse;
    StepInstInfo.used = 1; 

  }
  // ==================== ARM[hŎsĂꍇ
  else{ // T_bit == 0
    InstTmp = *((volatile unsigned int *)CurrInstAddr);

    cond = (InstTmp >> 28) & 0xF;
    opcode = (InstTmp >> 24) & 0xF;
    opcode_sub = (InstTmp >> 20) & 0xF;
  
    StepInstInfo.ModeFalse = ARM_MODE; 
    StepInstInfo.AddrFalse = CurrInstAddr + 4;
    StepInstInfo.InstFalse = *((volatile unsigned int *)StepInstInfo.AddrFalse);
    *((volatile unsigned int *)StepInstInfo.AddrFalse) = ILLEGAL_INST_ARM;


    if((opcode & 0xE) == 0xA){ // B
      if((InstTmp & (1<<23)) == 0) // rbg0
	addr_offset = (InstTmp & 0xFFFFFF) << 2;
      else // rbg1
	addr_offset = ((InstTmp & 0xFFFFFF) | 0xFF000000) << 2;

      if(cond == 0xF){ // BLX(1)̂Ƃ(BLX func_label)
	if((opcode & 0x1) != 0) // H == 1
	  addr_offset |= 0x2;
	else
	  addr_offset &= ~0x2;
      }

      StepInstInfo.ModeTrue = ARM_MODE; 
      StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 8;
      StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
      StepInstInfo.used = 1;
      return;
    }
    else if((opcode & 0xE) == 0x8 && (opcode_sub & 0x1) == 0x1){ // LDM (1) or LDM (3) GCCłreturn͑SĂB LDM sp, {r11, sp, pc}
      if((InstTmp & (1<<15)) != 0){ // PCXgɂ
	Rn = ((InstTmp >> 16) & 0xF);
	addr_offset = 0;
	for(i=0;i<15;i++){ // r0-r14
	  if((InstTmp & (1<<i)) != 0)
	    addr_offset += 4;
	}
	// Read Rn
	RnVal = registers[Rn];
	RnVal = *((unsigned int *)(RnVal + addr_offset));
	StepInstInfo.AddrTrue = RnVal & 0xFFFFFFFE;
	if((RnVal & 0x1) == 0){
	  StepInstInfo.ModeTrue = ARM_MODE; 
	  StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	  *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
	}
	else{
	  StepInstInfo.ModeTrue = THUMB_MODE; 
	  StepInstInfo.InstTrue = (short)*((volatile unsigned short *)StepInstInfo.AddrTrue);
	  *((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	}
	StepInstInfo.used = 1;
	return;
      }
    }
    else if(opcode == 0x1 && opcode_sub == 0x2){ // BX, BLX(2)
      Rd = InstTmp & 0xF;
      // Read Rd
      RmVal = registers[Rm];
      StepInstInfo.AddrTrue = DestAddr & 0xFFFFFFFE;
      if((DestAddr & 0x1) != 0){ // To Thumb
	StepInstInfo.ModeTrue = THUMB_MODE; 
	StepInstInfo.InstTrue = *((volatile unsigned short *)StepInstInfo.AddrTrue);
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      }
      else { // To ARM
	StepInstInfo.ModeTrue = ARM_MODE; 
	StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	*((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
      }
      StepInstInfo.used = 1;
      return;
    }
    else if((opcode & 0xd) != 0x1 && (opcode_sub & 0xe) == 0xc){ // MOV
      Rd = (InstTmp>>12) & 0xF;
      if(Rd == 15){ // PĈƂ
	I_bit = 0;
	S_bit = 0;
	if((InstTmp & (1<<25)) == 0)
	  I_bit = 1;
	if((InstTmp & (1<<20)) == 0)
	  S_bit = 1;
      
	if(I_bit == 1){
	  shifter_operand = (InstTmp & 0xFF);
	  rotate_imm = ((InstTmp>>8) & 0xF);
	  for(i=0;i<rotate_imm;i++){ // E[e[g
	    shifter_operand = ((shifter_operand & 0x1)<<31) & (shifter_operand >> 1);
	  }
	}
	else{ // I_bit == 0
	  if(((InstTmp>>4) & 0x7) == 0){
	    shift_imm = (InstTmp>>7) & 0x1F;

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    shifter_operand = RmVal << shift_imm;
	  }
	  else if(((InstTmp>>4) & 0x7) == 1){
	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) < 32)
	      shifter_operand = RmVal << (RsVal & 0xFF);
	    else
	      shifter_operand = 0;
	  }
	  else if(((InstTmp>>4) & 0x7) == 2){
	    shift_imm = (InstTmp>>7) & 0x1F;
	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if(shift_imm == 0)
	      shifter_operand = 0;
	    else
	      shifter_operand = RmVal >> shift_imm;
	  }
	  else if(((InstTmp>>4) & 0x7) == 3){
	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) < 32)
	      shifter_operand = RmVal >> (RsVal & 0xFF);
	    else
	      shifter_operand = 0;	  
	  }	
	  else if(((InstTmp>>4) & 0x7) == 4){
	    shift_imm = (InstTmp>>7) & 0x1F;
	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if(shift_imm == 0){
	      if((RmVal & (1<<31)) == 0)
		shifter_operand = 0;	  
	      else
		shifter_operand = 0xFFFFFFFF;
	    }
	    else
	      shifter_operand = RmVal >> shift_imm;
	  }	
	  else if(((InstTmp>>4) & 0x7) == 5){
	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) == 0)
	      shifter_operand = RmVal;
	    else if((RsVal & 0xFF) < 32)
	      shifter_operand = RmVal >> (RsVal & 0xFF);
	    else{
	      if((RmVal & (1<<31)) == 0)
		shifter_operand = 0;
	      else
		shifter_operand = 0xFFFFFFFF;
	    }
	  }	
	  else if(((InstTmp>>4) & 0x7) == 6){
	    shift_imm = (InstTmp>>7) & 0x1F;
	    // Read C flag
	    C_flag = (registers[CPSR] >> 29) & 0x1;
	  
	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if(shift_imm == 0)
	      shifter_operand = C_flag << 31 | (RmVal >> 1);
	    else
	      shifter_operand = RmVal >> shift_imm;
	  }	
	  else if(((InstTmp>>4) & 0x7) == 7){
	    // Read C flag
	    C_flag = (registers[CPSR] >> 29) & 0x1;

	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) == 0)
	      shifter_operand = RmVal;
	    else
	      if((RsVal & 0xF) == 0)
		shifter_operand = RmVal;
	      else{
		for(i=0;i<(RsVal & 0xF);i++){ // E[e[g
		  RmVal = ((RmVal & 0x1)<<31) & (RmVal >> 1);
		}
		shifter_operand = RmVal;
	      }
	  }

	  StepInstInfo.AddrTrue = shifter_operand;
	  StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	  *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
	  StepInstInfo.used = 1;
	  return;
	}
      }
    }
    else if((opcode & 0xc) != 0x4 && (opcode_sub & 0x5) == 0x1){ // LDR
      Rd = (InstTmp>>12) & 0xF;
      if(Rd == 15){ // PĈƂ
	I_bit = 0;
	P_bit = 0;
	U_bit = 0;
	W_bit = 0;
	if((InstTmp & (1<<25)) == 0)
	  I_bit = 1;
	if((InstTmp & (1<<24)) == 0)
	  P_bit = 1;
	if((InstTmp & (1<<23)) == 0)
	  U_bit = 1;
	if((InstTmp & (1<<21)) == 0)
	  W_bit = 1;

	if(I_bit == 0){
	  Rn = (InstTmp>>16) & 0xF;
	  // Read Rn
	  RnVal = registers[Rn];
	
	  if(W_bit == 0){
	    if(Rn == 15) // PC
	      RnVal += 8;
	  }

	  addr_offset = InstTmp & 0xFFF;
	  if(U_bit == 1)
	    LoadAddr = RnVal + addr_offset;
	  else
	    LoadAddr = RnVal - addr_offset;
	}
	else if(I_bit == 1){
	  if(((InstTmp>>4) & 0xFF) == 0){
	    Rn = (InstTmp>>16) & 0xF;
	    // Read Rn
	    RnVal = registers[Rn];
	  
	    if(W_bit == 0){
	      if(Rn == 15) // PC
		RnVal += 8;
	    }

	    Rm = InstTmp & 0xF;
	    // Read Rm
	    RmVal = registers[Rm];
	  
	    if(U_bit == 1)
	      LoadAddr = RnVal + RmVal;
	    else
	      LoadAddr = RnVal - RmVal;
	  }
	  else {
	    Rn = (InstTmp>>16) & 0xF;
	    // Read Rn
	    RnVal = registers[Rn];
	  
	    if(Rn == 15) // PC
	      RnVal += 8;
	  
	    Rm = InstTmp & 0xF;
	    // Read Rm
	    RmVal = registers[Rm];
	  
	    shift = (InstTmp >> 5) & 0x3;
	    shift_imm = (InstTmp >> 7) & 0x1F;
	    switch(shift){
	    case 0:
	      index = RmVal << shift_imm;
	      break;
	    case 1:
	      if(shift_imm == 0) index = 0;
	      else
		index = ((unsigned int)RmVal) >> shift_imm;
	      break;
	    case 2:
	      if(shift_imm == 0){
		if((RmVal & (1<<31)) != 0)
		  index = 0xFFFFFFFF;
		else
		  index = 0;
	      }
	      else
		index = RmVal >> shift_imm;
	      break;
	    case 3:
	      if(shift_imm == 0){
		// Read C flag
		C_flag = (registers[CPSR] >> 29) & 0x1;
		
		index = (C_flag << 31) | (((unsigned int)RmVal) >> 1);
	      }
	      else{
		for(i=0;i<shift_imm;i++){ // E[e[g
		  RmVal = ((RmVal & 0x1)<<31) & (RmVal >> 1);
		}
	      }
	    }
	    if(U_bit == 1)
	      LoadAddr = RnVal + index;
	    else
	      LoadAddr = RnVal - index;
	  }
	}
      
	if((LoadAddr & 0x3) == 0){
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	}
	else if((LoadAddr & 0x3) == 1){
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	  for(i=0;i<8;i++){ // E[e[g
	    LoadVal = ((LoadVal & 0x1)<<31) & (LoadVal >> 1);
	  }
	}
	else if((LoadAddr & 0x3) == 2){
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	  for(i=0;i<16;i++){ // E[e[g
	    LoadVal = ((LoadVal & 0x1)<<31) & (LoadVal >> 1);
	  }
	}
	else { // 3
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	  for(i=0;i<24;i++){ // E[e[g
	    LoadVal = ((LoadVal & 0x1)<<31) & (LoadVal >> 1);
	  }
	} 
      
	StepInstInfo.AddrTrue = LoadVal & 0xFFFFFFFE;
	if((LoadVal & 0x1) != 0){
	  *((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	  StepInstInfo.ModeTrue = THUMB_MODE;
	  StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
	}
	else{
	  *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
	  StepInstInfo.ModeTrue = ARM_MODE;
	  StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	}
	StepInstInfo.used = 1;
	return;
      }
    }

    StepInstInfo.ModeTrue = ARM_MODE; 
    StepInstInfo.AddrTrue = StepInstInfo.AddrFalse;
    StepInstInfo.InstTrue = StepInstInfo.InstFalse;
    StepInstInfo.used = 1; 
  }
}


void DeRegisterStep(){
  unsigned int CurrAddr;

  CurrAddr = registers[PC];

  if(StepInstInfo.used != 0){
    if(StepInstInfo.ModeTrue == ARM_MODE)
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = StepInstInfo.InstTrue;
    else
      *((volatile unsigned short *)StepInstInfo.AddrTrue) = (unsigned short)(StepInstInfo.InstTrue);
      
    if(StepInstInfo.ModeFalse == ARM_MODE)
      *((volatile unsigned int *)StepInstInfo.AddrFalse) = StepInstInfo.InstFalse;
    else
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = (unsigned short)(StepInstInfo.InstFalse);
      
    StepInstInfo.used = 0;
  }
}
