	.text

	.extern		main
	.extern		_sp_base
#======================================
#      Initialize vectors
#
##     0x00 	 Reset
##     0x04 	 Undefined Instruction
##     0x08 	 Software Interrupt
##     0x0c 	 Abort(prefetch)
##     0x10 	 Abort(data)
##     0x14 	 Reserved
##     0x18 	 IRQ
##     0x1c 	 FIQ
#======================================

	B	_startup
	B	_undefined_instruction_exception
	B	_software_exception
	B	_prefetch_abort_handle
	B	_data_abort_handle
	nop
	B	_IRQ_handle
	B	_FIQ_handle
	.org 0x20	
	.global _startup
_startup:
#IRQʒm󂯎悤ɐݒ肷
	MRS	R0, cpsr
	eor	R0, R0, #0x80
	MSR	cpsr, R0
#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1
#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base
#vZbT[h𖢒`ߗO[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x1B
	MSR	CPSR, R1
#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base
#vZbT[habt[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x17
	MSR	CPSR, R1
#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base
#vZbT[hX[p[oCU[h֖߂
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1
		
	LDR	R13,=_sp_base
	BL	main

	.extern stub_stack
	.extern registers
	.extern _illegalinst_func
# GDBŐݒ肳ꂽu[N|CgOŁA
# _E[hꂽvOł͎gp֎~
	.align 0x4
_undefined_instruction_exception: 
	#OpX^bNɃWX^ޔ	
	STMDB	sp!,{r0-r12,r14}
	
	#WX^L^܂B
	ldr	r0 ,=registers
	mov	r1 , sp
	# R0
	ldr	r2, [r1, #0]
	str	r2, [r0, #0]
	# R1
	ldr	r2, [r1, #4]
	str	r2, [r0, #4]
	# R2
	ldr	r2, [r1, #8]
	str	r2, [r0, #8]
	# R3
	str	r3, [r0, #12]
	# R4
	str	r4, [r0, #16]
	# R5
	str	r5, [r0, #20]
	# R6
	str	r6, [r0, #24]
	# R7
	str	r7, [r0, #28]
	# R8
	str	r8, [r0, #32]
	# R9
	str	r9, [r0, #36]
	# R10
	str	r10, [r0, #40]
	# R11
	str	r11, [r0, #44]
	# R12
	str	r12, [r0, #48]
	# R13

	#vZbT[hX[p[oCU[h֖߂
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	str	sp, [r0, #52]

	#vZbT[h𖢒`ߗO[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x1B
	MSR	CPSR, R1

	# R14
	#vZbT[hX[p[oCU[h֖߂
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1	

	str	r14, [r0, #56]
	
	#vZbT[h𖢒`ߗO[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x1B
	MSR	CPSR, R1

	# R15=PC
	MRS	r2, spsr
	and	r2, r2, #0x20
	cmp	r2, #0x20
	beq	_thumb_mode_ill
	SUB	r2, r14, #4
	B	_arm_mode_ill
_thumb_mode_ill:
	SUB	r2, r14, #2
_arm_mode_ill:
#	str	r2, [r0, #56]
	str	r2, [r0, #60]
	# F0-F7 (12byte x 8) = 96 byte offset
	# CPSR
	MRS	r1, spsr	
	str	r1, [r0, #166]
	
	bl	_illegalinst_func

#### Added from here
	MRS	r2, spsr
	and	r2, r2, #0x20
	cmp	r2, #0x20
	beq	_ill_thumb_mode_ret
	B	_ill_arm_mode_ret
_ill_thumb_mode_ret:
	LDMIA	sp!,{r0-r12,r14}

	#`߂̔ԒnɕA
	subs	PC, R14, #2
_ill_arm_mode_ret:
#### untile here
	LDMIA	sp!,{r0-r12,r14}

	#`߂̔ԒnɕA
	subs	PC, R14, #4
###
	.align 0x4
_software_exception:
	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0]
	add	R0, R0, #8
	mov	pc, r0

	

#ȉ̗O̓_E[hX^[gAbv[`̂̂g
#ɂ̂܂ܕ򂷂
	.align 0x4
_prefetch_abort_handle:	
	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0]
	add	R0, R0, #0xC
	mov	PC, R0	
_data_abort_handle:
	#OpX^bNr0ޔ
	STMFD	sp!, {r0}
	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0, #0]
	add	R0, R0, #0x10
	bx	R0
	
_IRQ_handle:	
	#OpX^bNɃWX^ޔ
	STMDB	sp!,{r0-r12, r14}
	
	#WX^L^܂B
	ldr	r0 ,=registers
	mov	r1 , sp
	# R0
	ldr	r2, [r1, #0]
	str	r2, [r0, #0]
	# R1
	ldr	r2, [r1, #4]
	str	r2, [r0, #4]
	# R2
	ldr	r2, [r1, #8]
	str	r2, [r0, #8]
	# R3
	str	r3, [r0, #12]
	# R4
	str	r4, [r0, #16]
	# R5
	str	r5, [r0, #20]
	# R6
	str	r6, [r0, #24]
	# R7
	str	r7, [r0, #28]
	# R8
	str	r8, [r0, #32]
	# R9
	str	r9, [r0, #36]
	# R10
	str	r10, [r0, #40]
	# R11
	str	r11, [r0, #44]
	# R12
	str	r2, [r0, #48]
	# R13
	#vZbT[hX[p[oCU[h֖߂
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	str	sp, [r0, #52]

	#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1
	

	# R14
	#vZbT[hX[p[oCU[h֖߂
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1	

	str	r14, [r0, #56]	

	#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1

	# R15=PC
	#Thumb̂ƂAARM̗̎OLRPC+4łB
	SUB	r2, r14, #4
	str	r2, [r0, #60]
	# F0-F7 (12byte x 8) = 96 byte offset
	# CPSR
	MRS	r1, spsr	
	str	r1, [r0, #166]
	
	#UART0̎MOȂ̂ŁAGDB
	#VICIRQ Status6rbgڂ
	#UART0IIR2-3rbgڂ0x2GDB
	#VIC IRQ Status
	LDR	R0, =0xFFFFF000
	LDR	R0, [R0]
	AND	R0, R0, #0x40
	CMP	R0, #0x40
	bleq	_UART0_IRQ_IRQ
	b	_user_IRQ_branch
_UART0_IRQ_IRQ:
	#COM IIR
	LDR	R0, =0xE000C008 
	LDR	R0, [R0]
	AND	R0, R0, #0x6
	CMP	R0, #0x4
	bleq	_UART0_RX_INT_IRQ
	b	_user_IRQ_branch
_UART0_RX_INT_IRQ:	
	bl	_int_func

	#OpX^bN烌WX^A	
	LDMIA	sp!,{r0-r12, r14}

	SUBS	PC, R14, #4
	
_user_IRQ_branch:	
	#OpX^bN烌WX^A	
	LDMIA	sp!,{r0-r12, r14}

	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0]
	add	R0, R0, #0x18
	mov	PC, R0

	.align 0x4
_FIQ_handle:	
	#OpX^bNɃWX^ޔ
	STMDB	sp!,{r0-r12}
	MRS	r0, spsr
	STMDB	sp!, {r0}

#vZbT[hX[p[oCU[h֖߂
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	#[hWX^L^܂B
	ldr	r0 ,=registers
	STMIA	r0!,{r0-r14}

#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1

	#Thumb̂ƂAARM̗̎OLRPC+4łB
	SUB	r2, r14, #4
	str	r2, [r0, #0]

	#UART0̎MOȂ̂ŁAGDB
	#VICIRQ Status6rbgڂ
	#UART0IIR2-3rbgڂ0x2GDB
	#VIC IRQ Status
	LDR	R0, =0xFFFFF000
	LDR	R0, [R0]
	AND	R0, R0, #0x40
	CMP	R0, #0x40
	bleq	_UART0_IRQ_FIQ
	b	_user_IRQ_branch
_UART0_IRQ_FIQ:
	#COM IIR
	LDR	R0, =0xE000C008 
	LDR	R0, [R0]
	AND	R0, R0, #0x6
	CMP	R0, #0x4
	bleq	_UART0_RX_INT_FIQ
	b	_user_IRQ_branch
_UART0_RX_INT_FIQ:	
	bl	_int_func

	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12}

	SUBS	PC, R14, #4
	
	.align 0x4
_user_FIQ_branch:	
	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12}

	#OpX^bNr0ޔ
	STMDB	sp!, {r0}

	LDR	R0,=_user_exception_vector_addr
	LDR	R0, [R0, #0]
	add	R0, R0, #0x1C
	mov	PC, R0	


	