#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include <monitor.h>

#define MONITOR_MAJOR_VER 1
#define MONITOR_MINOR_VER 0

#define MONITOR_REL_DATE "2009 April"

// R}h̕`
#define READBYTE_COMMAND_STR "rb"
#define READSHORT_COMMAND_STR "rw"
#define READLONG_COMMAND_STR "rl"
#define WRITEBYTE_COMMAND_STR "wb"
#define WRITESHORT_COMMAND_STR "ww"
#define WRITELONG_COMMAND_STR "wl"
#define DUMPBYTE_COMMAND_STR "db"
#define DUMPSHORT_COMMAND_STR "dw"
#define DUMPLONG_COMMAND_STR "dl"
#define DOWNLOADRUN_COMMAND_STR "dr"
#define HELP_COMMAND_STR "help"
#define SHOWREG_COMMAND_STR "sr"
#define EXITMONITOR_COMMAND_STR "em"

unsigned int monitor_registers[NUM_REGS];

#define MAX_LINES 32 // 1s32܂
#define MAX_HISTORY 4 // qXg͂S܂
char cmd_history[MAX_HISTORY][MAX_LINES];

// start_addrlengthoCgǂݏoA
// Wo͂ɏo܂B
static void readmem(unsigned int start_addr, int length){

  if(length == 1){ // BYTE
    printf("%.8p : %.2x\r\n", (unsigned char *)start_addr, ((unsigned char *)start_addr)[0]);
  }
  else if(length == 2){ // SHORT
    printf("%.8p : %.4x\r\n", (unsigned short *)start_addr, ((unsigned short *)start_addr)[0]);
  }
  else if(length == 4){ // LONG
    printf("%.8p : %.8x\r\n", (unsigned int *)start_addr, ((unsigned int *)start_addr)[0]);
  }
}

// elengthoCgWo͂Ƀ_v܂B
// mode1,2,4̂ǂꂩw肵āA؂oCgw肵܂B
static void dumpmem(unsigned int start_addr, int length, int mode){
  int i,j;

  switch(mode){
  case 1:
    printf("   addr : +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F | ASCII\r\n");
    for(i=0;i<length/16;i++){
      printf("%.8x:", start_addr+i*16);
      for(j=0;j<16;j++)
	printf(" %.2x",*((unsigned char *)(start_addr+i*16)+j));
      printf(" | ");
      for(j=0;j<16;j++)
	if(*((char *)(start_addr+i*16)+j) < 0x20)
	  printf(".");
	else
	  printf("%c",(*((char *)(start_addr+i*16)+j))&0x7f);
      printf("\r\n");
    }
    break;
  case 2:
    printf("   addr : +0000 +0002 +0004 +0006 +0008 +000A +000C +000E | ASCII\r\n");
    for(i=0;i<length/16;i++){
      printf("%.8x:", start_addr+i*16);
      for(j=0;j<8;j++)
	printf("  %.4x",*((unsigned short *)(start_addr+i*16)+j));
      printf(" | ");
      for(j=0;j<16;j++)
	if(*((char *)(start_addr+i*16)+j) < 0x20)
	  printf(".");
	else
	  printf("%c",(*((char *)(start_addr+i*16)+j))&0x7f);
      printf("\r\n");
    }
    break;
  case 4:
    printf("   addr : +00000000 +00000004 +00000008 +0000000C | ASCII\r\n");
    for(i=0;i<length/16;i++){
      printf("%.8x:", start_addr+i*16);
      for(j=0;j<4;j++)
	printf("  %.8x",*((unsigned int *)(start_addr+i*16)+j));
      printf(" | ");
      for(j=0;j<16;j++)
	if(*((char *)(start_addr+i*16)+j) < 0x20)
	  printf(".");
	else
	  printf("%c",(*((char *)(start_addr+i*16)+j))&0x7f);
      printf("\r\n");
    }
    break;
  }  
}

// addrɎw肵f[^valoCgPʂŏ݂܂B
// length1,2,4w肵ďޒw肵܂B
static void writemem(unsigned int addr, unsigned int val, int length){
  volatile unsigned char *p;

  switch(length){
  case 1:
    printf("Writing 8bit \"HEX:0x%.2x\" to addr:0x%.8x..\r\n", val, addr);
    *((unsigned char *)addr) = val;
    break;
  case 2:
    printf("Writing 16bit \"HEX:0x%.4x\" to addr:0x%.8x..\r\n", val, addr);
    *((unsigned short *)addr) = val;
    break;
  case 4:
    printf("Writing 32bit \"HEX:0x%.8x\" to addr:0x%.8x..\r\n", val, addr);
    *((unsigned int *)addr) = val;
    break;
  }
}

// Motorola StH[}bg̃f[^W͂󂯎A
// start_addrɊJnAhXo͂܂B
// s-1Aƃ_E[hoCgԂ܂B
int Sdownloader(unsigned int *start_addr){
  int i,j;
  char c;
  int rec_len;
  int bytes = 0;
  char tmp_str[45];
  unsigned char *p;
  unsigned char checksum;

  while(1){
    if((c = getchar()) != EOF){
      if(c  == 'S'){
	checksum = 0;
	switch (c = getchar()){
	case '0':
	  // R[h̃TCY
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<2;i++){
	    tmp_str[i] = getchar();
	  }
	  rec_len = strtoul(tmp_str,NULL,16);
	  checksum = rec_len;
	  rec_len --; //g̕
	  // S0̓AhXtB[h2oCgłׂ0Ȃ̂œǂݔ΂
	  for(i=0;i<2;i++){
	    for(j=0;j<2;j++){
	      tmp_str[i*2+j] = getchar();
	    }
	    checksum += (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	  }
	  rec_len -= 2;
	  // W[20oCg
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  printf("Module name : ");fflush(stdout);
	  for(i=0;i<20;i++){
	    for(j=0;j<2;j++){
	      if(rec_len == 0) goto S0_module_end;
	      tmp_str[i*2+j] = getchar();
	    }
	    rec_len --;
	    tmp_str[i] = (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	    checksum += tmp_str[i];
	  }
	S0_module_end:
	  tmp_str[i] = '\0';
	  printf("%s\r\n",tmp_str);
	  if(rec_len == 0) break;
	  
	  // o[W2oCg
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  printf("Module version : ");fflush(stdout);
	  for(i=0;i<2;i++){
	    for(j=0;j<2;j++){
	      if(rec_len == 0) goto S0_version_end;
	      tmp_str[i*2+j] = getchar();
	      checksum += tmp_str[i];
	    }
	    rec_len --;
	    tmp_str[i*2+2] = '\0';
	    tmp_str[i] = (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	  }
	S0_version_end:
	  tmp_str[i] = '\0';
	  printf("%s\r\n",tmp_str);
	  if(rec_len == 0) break;
	  
	  // rW2oCg
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  printf("Module Revision : ");fflush(stdout);
	  for(i=0;i<2;i++){
	    for(j=0;j<2;j++){
	      if(rec_len == 0) goto S0_revision_end;
	      tmp_str[i*2+j] = getchar();
	      checksum += tmp_str[i];
	    }
	    rec_len --;
	    tmp_str[i*2+2] = '\0';
	    tmp_str[i] = (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	  }
	S0_revision_end:
	  tmp_str[i] = '\0';
	  printf("%s\r\n",tmp_str);
	  if(rec_len == 0) break;
	  break;
	case '1':
	case '2':
	case '3':
	  // R[h̃TCY
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<2;i++){
	    tmp_str[i] = getchar();
	  }
	  rec_len = strtoul(tmp_str,NULL,16);
	  checksum = rec_len;
	  rec_len --; //g̕
	  // AhXtB[hc-'0'+1oCg
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<(c-'0')+1;i++){
	    for(j=0;j<2;j++){
	      tmp_str[i*2+j] = getchar();
	    }
	    checksum += (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	    rec_len --;
	  }
	  tmp_str[(c-'0'+1)*2] = '\0';
	  p = (unsigned char *)strtoul(tmp_str,NULL,16);
	  printf("Addr:0x%.8x ",p); fflush(stdout);

	  // f[^1oCg
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<rec_len;i++){
	    for(j=0;j<2;j++){
	      tmp_str[i*2+j] = getchar();
	    }
	    checksum += (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	    *p = (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	    p++;
	    bytes ++;
	    putchar('.'); fflush(stdout);
	  }
	  break;
	case '5':
	  // R[h̃TCY
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<2;i++){
	    tmp_str[i] = getchar();
	  }
	  rec_len = strtoul(tmp_str,NULL,16);
	  checksum = rec_len;
	  rec_len --; //g̕
	  // S1,S2,S3̍s
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<rec_len;i++){
	    for(j=0;j<2;j++){
	      tmp_str[i*2+j] = getchar();
	    }
	    tmp_str[i] = (unsigned char)strtoul(&tmp_str[i*2],NULL,16);
	    checksum += tmp_str[i];
	  }
	  tmp_str[rec_len] = '\0';
	  rec_len = strtoul(tmp_str,NULL,16);
	  printf("Number of lines = %s\r\n", tmp_str);
	  goto S_nochecksum;
	case '7':
	case '8':
	case '9':
	  // R[h̃TCY
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  for(i=0;i<2;i++){
	    tmp_str[i] = getchar();
	  }
	  rec_len = strtoul(tmp_str,NULL,16);
	  checksum = rec_len;
	  rec_len --; //g̕
	  // AhXtB[h4-(c-'7')oCg
	  for(i=0;i<40;i++) tmp_str[i] = '\0';
	  *start_addr = 0;
	  for(i=0;i<(4-(c-'7'));i++){
	    for(j=0;j<2;j++){
	      tmp_str[i*2+j] = getchar();
	      *start_addr += ((strtoul(&tmp_str[i*2+j],NULL,16)&0xFF) << ((7-(i*2+j))*4));
	    }
	    checksum += (unsigned int)strtoul(&tmp_str[i],NULL,16);
	  }
	  *start_addr = strtoul(tmp_str,NULL,16);
	  printf("Start addr : 0x%.8x\r\n",*start_addr);
	  break;
	default:
	  printf("Unknown record S%c\r\n",c);
	  return -1;
	}
	// `FbNT2oCg
	for(i=0;i<2;i++)
	  tmp_str[i] = getchar();
	tmp_str[2] = '\0';
	tmp_str[0] = (char)strtoul(tmp_str,NULL,16);
	if(((tmp_str[0] + checksum)&0xFF) != 0xFF){
	  printf("Checksum error. %.2x != %.2x\r\n",~checksum&0xFF,tmp_str[0]&0xFF);
	  return -1;
	}
	printf("Checksum OK.\r\n");
	// StH[}bg̍ŌɊJnAhX̂ŁAŏI
	if(c >= '7'){
	  // \rǂݔ΂
	  getchar();
	  break;
	}
      S_nochecksum:
	  continue;
      }
    }
  }
  return bytes;
}

int curr_history;
int num_history;
char new_cmdline[MAX_LINES];
char command[10];

// _v̊JnAhX
unsigned int dump_start_addr;


void init_monitor(){
  int i,j;

  init_stdin_int();

  dump_start_addr = 0x0;

  // R}hqXg
  for(i=0;i<MAX_HISTORY;i++)
    for(j=0;j<MAX_LINES;j++)
      cmd_history[i][j] = 0;
  
  num_history = 0;
  curr_history = 0;
}

// ^[~iŃ^[͂܂ł̃R}hC
// R}hi0Ԗڂ̕jAIvViR}hɑjɕB
// IvV͐lł邱ƂO
char *cmdline_parser(int *opt0, int *opt1){
  char c;
  int curr_c;
  char *p;
  int history_index, history_num_tmp;
  char option_str[2][20];
  int i,j;

  history_index = curr_history;
  history_num_tmp = num_history;
  curr_c = 0;

  for(i=0;i<MAX_LINES;i++)
    new_cmdline[i] = 0;

  while((c=tolower(getchar())) != '\r'){
    // ^[͂ꂽ͊Ƃ
    if(c == '\r'){
      if(curr_c != 0) break;
    }

    if(c == 0x10 && history_num_tmp != 0){ // Ctr-p
      for(i=0;i<MAX_LINES;i++)
	new_cmdline[i] = 0;

      history_index = history_index == 0 ? (MAX_HISTORY-1) : (history_index - 1);
      strcpy(new_cmdline, cmd_history[history_index]);
      curr_c = strlen(new_cmdline) + 1;
      // Xy[XŏB
      printf("\r>                                            "); fflush(stdout);
      printf("\r> %s", new_cmdline); fflush(stdout);
      history_num_tmp --;
    }
    else{
      printf("\r> %s", new_cmdline); fflush(stdout);
    }
    if(c == 0x0e && history_num_tmp < (num_history-1)){ // Ctr-n
      for(i=0;i<MAX_LINES;i++)
	new_cmdline[i] = 0;

      history_index = (history_index + 1)%MAX_HISTORY;
      strcpy(new_cmdline, cmd_history[history_index]);
      curr_c = strlen(new_cmdline) + 1;
      // Xy[XŏB
      printf("\r>                                            "); fflush(stdout);
      printf("\r> %s", new_cmdline); fflush(stdout);
      history_num_tmp ++;
    }
    else{
      printf("\r> %s", new_cmdline); fflush(stdout);
    }
    
    if(c == 0x08){ // BS
      if(curr_c != 0){
	new_cmdline[curr_c-1] = '\0';
	curr_c --;
	// Xy[XŏB
	printf("\r>                                            "); fflush(stdout);
	printf("\r> %s", new_cmdline); fflush(stdout);
      }
      else{
	printf("\r> %s", new_cmdline); fflush(stdout);
      }
    }
    // 0-9AA-ZAa-zAXy[X͓͂ł悤ɂ
    if((('0' <= c) && (c <= '9'))
       || (('a' <= c) && (c <= 'z'))
       || (('A' <= c) && (c <= 'Z'))
       || (c == ' ')){
      new_cmdline[curr_c] = c;
      curr_c ++;
      new_cmdline[curr_c] = '\0';
      printf("\r> %s", new_cmdline); fflush(stdout);
    }
  }

  p = new_cmdline;
  i = 0;
  j = 0;
  // ̃Xy[XXLbv
  while(p[i] == ' ') i++;
  // R}hRs[
  while(p[i] != ' '){
    if(p[i] == '\0') break;
    command[j] = p[i];
    i++;
    j++;
  }
  command[j] = '\0';

  i ++;
  j = 0;
  // Xy[XXLbv
  while(p[i] == ' ') i++;
  // option0Rs[
  while(p[i] != ' '){
    if(p[i] == '\0') break;
    option_str[0][j] = p[i];
    i++;
    j++;
  }
  option_str[0][j] = '\0';

  if(strlen(option_str[0]) == 0)
    *opt0 = -1;
  else
    *opt0 = strtoul(option_str[0], NULL, 16);

  i ++;
  j = 0;
  // Xy[XXLbv
  while(p[i] == ' ') i++;
  // option1Rs[
  while(p[i] != ' '){
    if(p[i] == '\0') break;
    option_str[1][j] = p[i];
    i++;
    j++;
  }
  option_str[1][j] = '\0';

  if(strlen(option_str[1]) == 0)
    *opt1 = -1;
  else
    *opt1 = strtoul(option_str[1], NULL, 16);

  printf("\r\n");
  return command;

}

// qXgAbvf[g֐
void update_cmd_history(){
  int j;

  
  for(j=0;j<MAX_LINES;j++)
    cmd_history[curr_history][j] = 0;

  strcpy(cmd_history[curr_history], new_cmdline);
  curr_history = (curr_history + 1)%MAX_HISTORY;
  if(num_history != MAX_HISTORY)
    num_history ++;

}

int monitor(){
  char *menu_str;
  char addr_str[20];
  char len_str[20];
  int filesize;
  int i,j;
  unsigned int start_addr;
  int option0,option1;

  volatile unsigned char *SCR0,*SCR1;
  volatile unsigned short *IPRF;
  IPRF = (unsigned short *)0xFFFF8352;
  SCR0 = (unsigned char *)0xFFFF81A2;
  SCR1 = (unsigned char *)0xFFFF81B2;

  // _E[hꂽ֐ւ̃|C^
  int (*target_main)();


  // ŏ̋NbZ[W
  printf("=========== CQ embedded monitor ==========\r\n");
  printf("==== Copyright (C) Shinichi Yamagiwa =====\r\n");
  printf("=== Ver. %d.%d  (Released on %s) ===\r\n",
	 MONITOR_MAJOR_VER, MONITOR_MAJOR_VER,
	 MONITOR_REL_DATE);

  // quitI΂܂Ŗ[v
  while(1){
    printf("> "); fflush(stdout);
    menu_str = cmdline_parser(&option0,&option1);

    // helpR}h
    if(strcmp(menu_str, HELP_COMMAND_STR) == 0){
      printf("Commands:\r\n");
      printf("\t%s HEX => read byte(8bit) from HEX address\r\n",READBYTE_COMMAND_STR);
      printf("\t%s HEX => read short(16bit) from HEX address\r\n",READSHORT_COMMAND_STR);
      printf("\t%s HEX => read long(32bit) from HEX address\r\n",READLONG_COMMAND_STR);
      printf("\t%s HEXA HEXD => write HEXD byte(8bit) into HEXA address\r\n", WRITEBYTE_COMMAND_STR);
      printf("\t%s HEXA HEXD => write HEXD short(16bit) into HEXA address\r\n", WRITESHORT_COMMAND_STR);
      printf("\t%s HEXA HEXD => write HEXD long(32bit) into HEXA address\r\n", WRITELONG_COMMAND_STR);
      printf("\t%s HEX => dump 256 bytes from HEX address in byte(8bit) format\r\n",DUMPBYTE_COMMAND_STR);
      printf("\t%s HEX => dump 256 bytes from HEX address in short(16bit) format\r\n",DUMPSHORT_COMMAND_STR);
      printf("\t%s HEX => dump 256 bytes from HEX address in long(32bit) format\r\n",DUMPLONG_COMMAND_STR);
      printf("\t%s => download and run with Motorola S format\r\n",DOWNLOADRUN_COMMAND_STR);
      printf("\t%s => show register\r\n\tem => exit from monitor\r\n", SHOWREG_COMMAND_STR);
      continue;
    }
    // ReadByteR}h
    if(strcmp(menu_str, READBYTE_COMMAND_STR) == 0){
      if(option0 == -1){
	printf("rb command needs an address option\r\n");
      }
      else{
	readmem(option0, 1);
	update_cmd_history();
      }
      continue;
    }

    // ReadShortR}h
    if(strcmp(menu_str, READSHORT_COMMAND_STR) == 0){
      if(option0 == -1){
	printf("rb command needs an address option\r\n");
      }
      else{
	readmem(option0, 2);
	update_cmd_history();
      }
      continue;
    }

    // ReadLongR}h
    if(strcmp(menu_str, READLONG_COMMAND_STR) == 0){
      if(option0 == -1){
	printf("rb command needs an address option\r\n");
      }
      else{
	readmem(option0, 4);
	update_cmd_history();
      }
      continue;
    }

    // DumpByteR}h
    if(strcmp(menu_str, DUMPBYTE_COMMAND_STR) == 0){
      unsigned int start_addr;

      printf("dumpbyte command\r\n");

      if(option0 == -1){
	start_addr = dump_start_addr;
      }
      else{
	start_addr = option0;
      }
      dumpmem(start_addr, 256, 1);
      dump_start_addr = start_addr;
      update_cmd_history();
      
      continue;
    }
    // DumpShortR}h
    if(strcmp(menu_str, DUMPSHORT_COMMAND_STR) == 0){
      unsigned int start_addr;

      if(option0 == -1){
	start_addr = dump_start_addr;
      }
      else{
	start_addr = option0;
      }
      dumpmem(start_addr, 256, 2);
      dump_start_addr = start_addr;
      update_cmd_history();
      
      continue;
    }
    // DumpLongR}h
    if(strcmp(menu_str, DUMPLONG_COMMAND_STR) == 0){
      unsigned int start_addr;

      if(option0 == -1){
	start_addr = dump_start_addr;
      }
      else{
	start_addr = option0;
      }
	
      dumpmem(start_addr, 256, 4);
      dump_start_addr = start_addr;
      update_cmd_history();
      
      continue;
    }

    // WriteByteR}h
    if(strcmp(menu_str, WRITEBYTE_COMMAND_STR) == 0){
      if((option0 == -1) || (option1 == -1)){
	printf("wb command needs an address option and an byte value option.\r\n");
      }
      else{
	writemem(option0,option1, 1);
	update_cmd_history();
      }
      continue;
    }	
    
    // WriteShortR}h
    if(strcmp(menu_str, WRITESHORT_COMMAND_STR) == 0){
      if((option0 == -1) || (option1 == -1)){
	printf("wb command needs an address option and an byte value option.\r\n");
      }
      else{
	writemem(option0,option1 ,2);
	update_cmd_history();
      }
      continue;
    }	
    
    // WriteLongR}h
    if(strcmp(menu_str, WRITELONG_COMMAND_STR) == 0){
      if((option0 == -1) || (option1 == -1)){
	printf("wb command needs an address option and an byte value option.\r\n");
      }
      else{
	writemem(option0,option1,4);
	update_cmd_history();
      }
      continue;
    }	
    
    // Download&RunR}h
    if(strcmp(menu_str, DOWNLOADRUN_COMMAND_STR) == 0){
      printf("Waiting for a Motorla S format file...\r\n");
      filesize = Sdownloader(&start_addr);
      if(filesize == -1){
	printf("download failed.\r\n");
	continue;
      }
      else{
	printf("Successfull, downloaded %dbytes\r\n", filesize);
	printf("Branch to 0x%.8x\r\n", start_addr);
	
	enable_stdin_int();

	// _E[hꂽ֐ւ̃|C^ɊJnAhX
	target_main = (void *)start_addr;
	// _E[hꂽ֐Ăт
	target_main();
	
	disable_stdin_int();
	
	update_cmd_history();
	continue;
      }
    }
    
    // ShowRegisterR}h
    if(strcmp(menu_str, SHOWREG_COMMAND_STR) == 0){
      show_register();
      update_cmd_history();
      continue;
    }

    // ExitMonitorR}h
    if(strcmp(menu_str, EXITMONITOR_COMMAND_STR) == 0){
      printf("Returning from monitor.\r\n");
      return;
    }
    
    if(strlen(menu_str) != 0)
      printf("Invalid command : %s\r\n",menu_str); 
    else
      printf("\r\n");
  }
  
}

int main(){
  int i;

  init_monitor();

  // Ԉăj^甲Ƃɍ̂łŖ[v
  while(1){
    monitor();
  } 
  return 0;
}
